<%@ LANGUAGE=JSCRIPT %>

<%


// Contemplate Reporter (reporter.asp) version 1.2.2
// Copyright 1999-2007 Type A Learning Agency (http://www.typea.net)
// This file may be used, modified, or redistributed under the terms
// of the open-source agreement contained in docs/license.txt


	Server.ScriptTimeout = 300; // this is important for the reporter, since processing a data file can take several minutes
	
// this is a special JScript workaround for testing if an argument is set or not

	$undefined = Request.QueryString("alkdjfalkdjajdslkfjdalsjfdajljf");


//  define some useful subroutines

	function get_file_simple($file) {
		$text = "";

		$file = $file.replace(/[^\w-\.\/\?\&\=\%]/g, ""); // don't read files whose names contain characters that could be used to read remote files, or to hack into the open command (Perl only)
		$file = absolute_path($file, "filesystem");
		FSO = Server.CreateObject("Scripting.FileSystemObject");
		$file_exists = FSO.FileExists($file);
		if (! $file_exists) {
			return "Error: Can't find file " + $file;
		} else {
			$myfile = FSO.OpenTextFile($file, 1, false, 0);
			$text = $myfile.ReadAll();
			$myfile.Close();
		}
		FSO = "";

		// conform all line breaks to avoid cross-platform issues
		$text = $text.replace(/\r\n/g, "\r"); // change DOS to Mac
		$text = $text.replace(/\n/g, "\r"); // change Unix to Mac

		// remove extra line breaks at the end of the file so all the languages perform splits in the same way
		$text = $text.replace(/(.*[^\r])\r*$/, "$1");
		
		return $text;	
	}
	
	function get_setting($source_text, $setting, $allow_override, $allow_partial) {
		// allow most preferences to be overridden through the argument string
		$value = "";
		$setting_no_spaces = $setting;
		$setting_no_spaces = String($setting_no_spaces).replace(/[ -]/g, "_");
		$settings_used += $setting_no_spaces + ",";

		$override = (Request.QueryString($setting_no_spaces) != $undefined) ? Request.QueryString($setting_no_spaces) : "" ;
		if (($allow_override)&&($override != "")) {
			$value = $override;
			// don't allow users to pass code through the URL arguments
			$value = $value.replace(/\</, "&lt;");
			$value = $value.replace(/\>/, "&gt;");
		} else {
			$source_text = "\r" + $source_text; // this makes it easy to make sure settings start on a new line
			if ($allow_partial) {  // this lets us use more verbose labels in the ini file
				$re = new RegExp('[^\\w]' + $setting + '[^:\r]*: ([^\r]*)\r*', 'i');
				if ($re.test($source_text)) {
					$value = RegExp.$1;
				}
			} else {  // this ensures an exact match in the pages file
				$re = new RegExp('[^\\w]' + $setting + ': ([^\r]*)\r*', 'i');
				if ($re.test($source_text)) {
					$value = RegExp.$1;
				}
			}
		}
		if ($value == "0") { $value = 0; } // this ensures that a 0 value will evaluate false in every language
		return $value;
	}

	function absolute_path($path, $method) { // convert a reference to a file within our site to a complete filesystem path or absolute URL

		if ($method == "filesystem") {
		
			//if ($script_location == "NA") {
			//	$output += show_error("Couldn't determine the filesystem path to this script. Please ensure that either the SCRIPT_FILENAME or PATH_TRANSLATED variable is available on your server.");
			//} else {
				$path = Server.MapPath($path);
			//}

		} else {
		
			if ($request == "NA") {
				$output += show_error("Couldn't determine the web path to this script. Please ensure that either the SCRIPT_NAME or REQUEST_URI variable is available on your server.");
			} else {
				$thisserver = (Request.ServerVariables("HTTP_HOST") != $undefined) ? String(Request.ServerVariables("HTTP_HOST")) : "" ;
				$thispath = "";
				if ($URL_rewriting_flag) {
					$re = new RegExp("\/([^=]*\/)" + $URL_rewriting_flag + "\/", "i");
					if ($re.test($request)) { $thispath = RegExp.$1; }
				} else {
					$re = new RegExp("\/([^=]*\/)contemplate\/", "i");
					if ($re.test($request)) { $thispath = RegExp.$1; }
				}
				
				// pass along the authentication information if present
				$auth_info = (Request.ServerVariables("HTTP_AUTHORIZATION") != $undefined) ? String(Request.ServerVariables("HTTP_AUTHORIZATION")) : "" ;
				if (($auth_info)&&($auth_info.substr(0, 5) == "Basic")) {
					$auth_info = $auth_info.substr(5);
					$login = Base64Decode($auth_info);
					$login += "@";
				} else {
					$login = "";
				}
				
				$path = $path.replace("../", "http://" + $login + $thisserver + "/" + $thispath, ""); // replace the first updelim with the scheme and path
				$path = $path.replace("../", "", "g"); // remove additional updelims
			}
		
		}
		
		return $path;
	}

	function random_color() {
		$colors = new Array("00","33","66","99","CC","FF");
		$r = $colors[Math.floor(Math.random() * 5)]; //rand(5) instead of rand(6) keeps them from getting too light to read
		$g = $colors[Math.floor(Math.random() * 5)];
		$b = $colors[Math.floor(Math.random() * 5)];
		$color = "#" + $r + $g + $b;
		return $color;	
	}
	
	function month_display($month) { // converts 2003-05 to May 2003
		$month_year = $month.split("-");
		$month_display = $months[parseFloat($month_year[1]) - 1];
		$year_display = $month_year[0];
		return $month_display + " " + $year_display;
	}
	
	
	function ucfirst($str) { // capitalizes the first character of $str; this is a substitute for PHP's ucfirst() built-in function
		return $str.replace(/.{1}/, $str.charAt(0).toUpperCase());
	}
	
	function regex_quote($source) { // this is a substitute for PHP's preg_quote() built-in function
		// PHP escapes: . \\ + * ? [ ^ ] $ ( ) { } = ! < > | :
		$source = $source.replace(/\\/g, "\\\\");
		$source = $source.replace(/\./g, "\\.");
		$source = $source.replace(/\+/g, "\\+");
		$source = $source.replace(/\*/g, "\\*");
		$source = $source.replace(/\?/g, "\\?");
		$source = $source.replace(/\[/g, "\\[");
		$source = $source.replace(/\^/g, "\\^");
		$source = $source.replace(/\]/g, "\\]");
		$source = $source.replace(/\$/g, "\\$");
		$source = $source.replace(/\(/g, "\\(");
		$source = $source.replace(/\)/g, "\\)");
		$source = $source.replace(/\{/g, "\\{");
		$source = $source.replace(/\}/g, "\\}");
		$source = $source.replace(/\//g, "\\/");
		$source = $source.replace(/\:/g, "\\:");
		return $source;
	}
	
	function array_unique($array) {
		$reversed = new Array();
		$result = new Array();
		for ($n=0; $n<$array.length; $n++) {
			$reversed[$array[$n]] = $array[$n];
		}
		for ($element in $reversed) {
			$result.push($element);
		}
		return $result;
	}

	function get_unix_time($date_time) { // converts an SQL date (yyyy-mm-dd or yyyy-mm-dd hh:mm:ss) to a Unix timestamp for use in PHP datetime functions
		$date_time = $date_time.split(" ");
		if ($date_time.length == 2) {
			$date = $date_time[0];
			$time = $date_time[1];
		} else {
			$date = $date_time[0];
			$time = "12:00:00";
		}
		
		// we added the fn_ prefix here to avoid conflicts with variables outside the function
		
		$date = $date.split("-");
		$time = $time.split(":");
		
		$fn_year = $date[0];
		$fn_month = $date[1];
		$fn_day = $date[2];
		
		$fn_hours = $time[0];
		$fn_minutes = $time[1];
		$fn_seconds = $time[2];

		$timestamp = new Date($fn_year, $fn_month, $fn_day, $fn_hours, $fn_minutes, $fn_seconds) / 1000;
		return $timestamp;
	}
	
	function wordwrap($string, $width, $delimiter) { // this is a substitute for PHP's wordwrap built-in function, with the $cut argument always true
		$result = "";
		while ($string.length > $width) {
			$result += $string.substr(0, $width) + $delimiter;
			$string = $string.substr($width, $string.length - $width);
		}
		$result += $string;
		return $result;
	}


// set up some primary variables

	// try to figure out the path to this script as it appears in the browser, before any URL rewriting
	// in IIS, this probably won't work, because REQUEST_URI will either not exist, or will show the path after rewriting, since rewriting is handled externally from IIS
	$request = "NA";
	if (Request.ServerVariables("REQUEST_URI") != $undefined) {
		$request = String(Request.ServerVariables("REQUEST_URI"));
		if ($request.indexOf("?") != -1) {
			$request = $request.substr(0, $request.indexOf("?"));
		}
	} else {
		// IIS doesn't always provide the REQUEST_URI variable
		if (Request.ServerVariables("SCRIPT_NAME") != $undefined) {
			$request = String(Request.ServerVariables("SCRIPT_NAME"));
		}
	}

	// if we know the browser path, figure out the part that triggers the rewrite; assume this is just one virtual directory name
	$re = new RegExp("contemplate/reporter", "");
	if (!$re.test($request)) {
		$re = new RegExp("([^\/]*)\/[^\/]+$", "i");
		if ($re.test($request)) { $URL_rewriting_flag = RegExp.$1; }
	} else {
		$URL_rewriting_flag = "";
	}

	// figure out the full local path of the contemplate directory so we can build an absolute path that works on Windows computers
	// on Unix, this will include any symlinks used to construct the URL, so we can run the script from a symlink to the real contemplate folder, 
	// and paths will be relative to the apparent, rather than the actual, location of assembler.asp
	// on Windows, this will not include virtual directories, but constructing a path from a virtual directory wouldn't work anyway
	// because those aren't available at the file system level
	$script_location = "NA";
	if (Request.ServerVariables("SCRIPT_FILENAME") != $undefined) {
		$script_location = String(Request.ServerVariables("SCRIPT_FILENAME"));
	} else {
		// Windows doesn't provide the SCRIPT_FILENAME variable
		if (Request.ServerVariables("PATH_TRANSLATED") != $undefined) {
			$script_location = String(Request.ServerVariables("PATH_TRANSLATED"));
		}
	}
	$script_location = $script_location.replace(/\\/g, "/");
	$re = new RegExp("(.*\/)" + $URL_rewriting_flag + "\/", "i");
	if (($URL_rewriting_flag)&&($re.test($script_location))) {
		$script_location = RegExp.$1 + "contemplate/";
	} else {
		$re = new RegExp("(.*\/)[^\/]+", "");
		if ($re.test($script_location)) { $script_location = RegExp.$1; }
	}
	
	$month = (Request.QueryString("month") != $undefined) ? String(Request.QueryString("month")) : "" ;
	$section = (Request.QueryString("section") != $undefined) ? Request.QueryString("section") : "" ;
	$clear = (Request.Form("clear") != $undefined) ? Request.Form("clear") : "" ;		
	$inspector_key = (Request.QueryString("inspector_key") != $undefined) ? String(Request.QueryString("inspector_key")) : "" ;		
	$inspector_value = (Request.QueryString("inspector_value") != $undefined) ? String(Request.QueryString("inspector_value")) : "" ;		
	$back_label = (Request.QueryString("back_label") != $undefined) ? Request.QueryString("back_label") : "" ;
	$realtime = (Request.QueryString("realtime") != $undefined) ? Request.QueryString("realtime") : "" ;
	
	$output = "";
	$button = "";
	$settings_used = "";
	$page_views_greatest = 1;
	$blank_marker = "--";
	$graph_width = 140;
	$my_host = (Request.ServerVariables("HTTP_HOST") != $undefined) ? String(Request.ServerVariables("HTTP_HOST")) : "" ;
	$my_domain = ($my_host.substr(0,4) == "www.") ? $my_host.substr(3, $my_host.length) : $my_host ;
	
	$show_performance = 0;
	$performance_times = "";
	$JScript_date = new Date();
	$last_performance_time = $JScript_date.getSeconds();
	$total_performance_time = 0;

	$data_directory = "../data/reporter/";
	$data_file = $data_directory + $month + ".txt";
	$error_file = $data_directory + $month + "-errors.txt";

	$columns = new Array("dates", "visitors", "IP_addresses", "hosts", "pages", "user_agents", "referrers");
	$columns_errors = new Array("dates", "visitors", "IP_addresses", "hosts", "pages", "user_agents", "referrers", "message");

	$sections = new Array("dates", "pages", "referrers", "entry_pages", "exit_pages", "visitors", "hosts", "countries", "IP_addresses", "user_agents");
	$sections_display = new Array("dates", "pages", "referrers", "entry pages", "exit pages", "visitors", "hosts", "countries", "IP addresses", "user agents");
	for ($i=0; $i<$sections.length; $i++) {
		eval("$" + $sections[$i] + " = new Array()");
	}
	
	$months = new Array("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");

	$HTTP_error_codes = new Array();
		$HTTP_error_codes["404"] = "File not found";
		$HTTP_error_codes["403"] = "Forbidden";
		$HTTP_error_codes["401"] = "Not authorized";

	$country_codes = new Array();
		$country_codes["com"] = "US Commercial";
		$country_codes["edu"] = "US Educational";
		$country_codes["org"] = "US Organization";
		$country_codes["net"] = "US Network";
		$country_codes["gov"] = "US Government";
		$country_codes["mil"] = "US Military";
		$country_codes["ac"] = "Ascension Island";
		$country_codes["ad"] = "Andorra";
		$country_codes["ae"] = "United Arab Emirates";
		$country_codes["af"] = "Afghanistan";
		$country_codes["ag"] = "Antigua and Barbuda";
		$country_codes["ai"] = "Anguilla";
		$country_codes["al"] = "Albania";
		$country_codes["am"] = "Armenia";
		$country_codes["an"] = "Netherland Antilles";
		$country_codes["ao"] = "Angola";
		$country_codes["aq"] = "Antarctica";
		$country_codes["ar"] = "Argentina";
		$country_codes["as"] = "American Samoa";
		$country_codes["at"] = "Austria";
		$country_codes["au"] = "Australia";
		$country_codes["aw"] = "Aruba";
		$country_codes["ax"] = "Aland Islands";
		$country_codes["az"] = "Azerbaijan";
		$country_codes["ba"] = "Bosnia and Herzegowina";
		$country_codes["bb"] = "Barbados";
		$country_codes["bd"] = "Bangladesh";
		$country_codes["be"] = "Belgium";
		$country_codes["bf"] = "Burkina Faso";
		$country_codes["bg"] = "Bulgaria";
		$country_codes["bh"] = "Bahrain";
		$country_codes["bi"] = "Burundi";
		$country_codes["bj"] = "Benin";
		$country_codes["bm"] = "Bermuda";
		$country_codes["bn"] = "Brunei Darussalam";
		$country_codes["bo"] = "Bolivia";
		$country_codes["br"] = "Brazil";
		$country_codes["bs"] = "Bahamas";
		$country_codes["bt"] = "Bhutan";
		$country_codes["bv"] = "Bouvet Island";
		$country_codes["bw"] = "Botswana";
		$country_codes["by"] = "Belarus";
		$country_codes["bz"] = "Belize";
		$country_codes["ca"] = "Canada";
		$country_codes["cc"] = "Cocos (Keeling) Islands";
		$country_codes["cd"] = "Congo";
		$country_codes["cf"] = "Central African Republic";
		$country_codes["cg"] = "Congo";
		$country_codes["ch"] = "Switzerland";
		$country_codes["ci"] = "Cte d'Ivoire";
		$country_codes["ck"] = "Cook Islands";
		$country_codes["cl"] = "Chile";
		$country_codes["cm"] = "Cameroon";
		$country_codes["cn"] = "China";
		$country_codes["co"] = "Columbia";
		$country_codes["cr"] = "Costa Rica";
		$country_codes["cs"] = "Czechoslovakia";
		$country_codes["cu"] = "Cuba";
		$country_codes["cv"] = "Cape Verde";
		$country_codes["cx"] = "Christmas Island";
		$country_codes["cy"] = "Cyprus";
		$country_codes["cz"] = "Czech Republic";
		$country_codes["de"] = "Germany";
		$country_codes["dj"] = "Djibouti";
		$country_codes["dk"] = "Denmark";
		$country_codes["dm"] = "Dominica";
		$country_codes["do"] = "Dominican Republic";
		$country_codes["dz"] = "Algeria";
		$country_codes["ec"] = "Ecuador";
		$country_codes["ee"] = "Estonia";
		$country_codes["eg"] = "Egypt";
		$country_codes["eh"] = "Western Sahara";
		$country_codes["er"] = "Eritrea";
		$country_codes["es"] = "Spain";
		$country_codes["et"] = "Ethiopia";
		$country_codes["eu"] = "European Union";
		$country_codes["fi"] = "Finland";
		$country_codes["fj"] = "Fiji";
		$country_codes["fk"] = "Falkland Islands";
		$country_codes["fm"] = "Micronesia";
		$country_codes["fo"] = "Faroe Islands";
		$country_codes["fr"] = "France";
		$country_codes["ga"] = "Gabon";
		$country_codes["gb"] = "United Kingdom";
		$country_codes["gd"] = "Grenada";
		$country_codes["ge"] = "Georgia";
		$country_codes["gf"] = "French Guiana";
		$country_codes["gg"] = "Guernsey";
		$country_codes["gh"] = "Ghana";
		$country_codes["gi"] = "Gibraltar";
		$country_codes["gl"] = "Greenland";
		$country_codes["gm"] = "Gambia";
		$country_codes["gn"] = "Guinea";
		$country_codes["gp"] = "Guadelope";
		$country_codes["gq"] = "Equatorial Guinea";
		$country_codes["gr"] = "Greece";
		$country_codes["gs"] = "S. Georgia/S. Sandwich Is.";
		$country_codes["gt"] = "Guatemala";
		$country_codes["gu"] = "Guam";
		$country_codes["gw"] = "Guinea-Bissau";
		$country_codes["gy"] = "Guyana";
		$country_codes["hk"] = "Hong Kong";
		$country_codes["hm"] = "Heard and McDonald Islands";
		$country_codes["hn"] = "Honduras";
		$country_codes["hr"] = "Croatia";
		$country_codes["ht"] = "Haiti";
		$country_codes["hu"] = "Hungary";
		$country_codes["id"] = "Indonesia";
		$country_codes["ie"] = "Ireland";
		$country_codes["il"] = "Israel";
		$country_codes["im"] = "Isle of Man";
		$country_codes["in"] = "India";
		$country_codes["io"] = "British Indian Ocean Territory";
		$country_codes["iq"] = "Iraq";
		$country_codes["ir"] = "Iran";
		$country_codes["is"] = "Iceland";
		$country_codes["it"] = "Italy";
		$country_codes["je"] = "Jersey";
		$country_codes["jm"] = "Jamaica";
		$country_codes["jo"] = "Jordan";
		$country_codes["jp"] = "Japan";
		$country_codes["ke"] = "Kenya";
		$country_codes["kg"] = "Kyrgystan";
		$country_codes["kh"] = "Cambodia";
		$country_codes["ki"] = "Kiribati";
		$country_codes["km"] = "Comoros";
		$country_codes["kn"] = "Saint Kitts and Nevis";
		$country_codes["kp"] = "Korea, People's Republic of";
		$country_codes["kr"] = "Korea, Republic of";
		$country_codes["kw"] = "Kuwait";
		$country_codes["ky"] = "Cayman Islands";
		$country_codes["kz"] = "Kazakhstan";
		$country_codes["la"] = "Lao Democratic Republic";
		$country_codes["lb"] = "Lebanon";
		$country_codes["lc"] = "Saint Lucia";
		$country_codes["li"] = "Liechtenstein";
		$country_codes["lk"] = "Sri Lanka";
		$country_codes["lr"] = "Liberia";
		$country_codes["ls"] = "Lethoso";
		$country_codes["lt"] = "Lithuania";
		$country_codes["lu"] = "Luxembourg";
		$country_codes["lv"] = "Latvia";
		$country_codes["ly"] = "Libyan Arab Jamahiriya";
		$country_codes["ma"] = "Morocco";
		$country_codes["mc"] = "Monaco";
		$country_codes["md"] = "Moldova";
		$country_codes["mg"] = "Madagascar";
		$country_codes["mh"] = "Marshall Islands";
		$country_codes["mk"] = "Macedonia";
		$country_codes["ml"] = "Mali";
		$country_codes["mm"] = "Myanmar";
		$country_codes["mn"] = "Mongolia";
		$country_codes["mo"] = "Macau";
		$country_codes["mp"] = "Northern Mariana Islands";
		$country_codes["mq"] = "Martinique";
		$country_codes["mr"] = "Mauritania";
		$country_codes["ms"] = "Montserrat";
		$country_codes["mt"] = "Malta";
		$country_codes["mu"] = "Mauritius";
		$country_codes["mv"] = "Maldives";
		$country_codes["mw"] = "Malawi";
		$country_codes["mx"] = "Mexico";
		$country_codes["my"] = "Malaysia";
		$country_codes["mz"] = "Mozambique";
		$country_codes["na"] = "Namibia";
		$country_codes["nc"] = "New Caledonia";
		$country_codes["ne"] = "Niger";
		$country_codes["nf"] = "Norfolk Island";
		$country_codes["ng"] = "Nigeria";
		$country_codes["ni"] = "Nicaragua";
		$country_codes["nl"] = "The Netherlands";
		$country_codes["no"] = "Norway";
		$country_codes["np"] = "Nepal";
		$country_codes["nr"] = "Nauru";
		$country_codes["nu"] = "Niue";
		$country_codes["nz"] = "New Zealand";
		$country_codes["om"] = "Oman";
		$country_codes["pa"] = "Panama";
		$country_codes["pe"] = "Peru";
		$country_codes["pf"] = "French Polynesia";
		$country_codes["pg"] = "Papua New Guinea";
		$country_codes["ph"] = "Philippines";
		$country_codes["pk"] = "Pakistan";
		$country_codes["pl"] = "Poland";
		$country_codes["pm"] = "St. Pierre and Miquelon";
		$country_codes["pn"] = "Pitcairn";
		$country_codes["pr"] = "Puerto Rico";
		$country_codes["ps"] = "Palestinian Territories";
		$country_codes["pt"] = "Portugal";
		$country_codes["pw"] = "Palau";
		$country_codes["py"] = "Paraguay";
		$country_codes["qa"] = "Qatar";
		$country_codes["re"] = "Reunion";
		$country_codes["ro"] = "Romania";
		$country_codes["ru"] = "Russia";
		$country_codes["rw"] = "Rwanda";
		$country_codes["sa"] = "Saudi Arabia";
		$country_codes["sb"] = "Solomon Islands";
		$country_codes["sc"] = "Seychelles";
		$country_codes["sd"] = "Sudan";
		$country_codes["se"] = "Sweden";
		$country_codes["sg"] = "Singapore";
		$country_codes["sh"] = "Saint Helena";
		$country_codes["si"] = "Slovenia";
		$country_codes["sj"] = "Svalbard/Jan Mayen Islands";
		$country_codes["sk"] = "Slovakia";
		$country_codes["sl"] = "Sierra Leone";
		$country_codes["sm"] = "San Marino";
		$country_codes["sn"] = "Senegal";
		$country_codes["so"] = "Somalia";
		$country_codes["sr"] = "Surinam";
		$country_codes["st"] = "Sao Tome and Principe";
		$country_codes["sv"] = "El Salvador";
		$country_codes["sy"] = "Syrian Arab Republic";
		$country_codes["sz"] = "Swaziland";
		$country_codes["tc"] = "The Turks & Caicos Islands";
		$country_codes["td"] = "Chad";
		$country_codes["tf"] = "French Southern Territories";
		$country_codes["tg"] = "Togo";
		$country_codes["th"] = "Thailand";
		$country_codes["tj"] = "Tajikistan";
		$country_codes["tk"] = "Tokelau";
		$country_codes["tl"] = "Timor-Leste";
		$country_codes["tm"] = "Turkmenistan";
		$country_codes["tn"] = "Tunesia";
		$country_codes["to"] = "Tonga";
		$country_codes["tp"] = "East Timor";
		$country_codes["tr"] = "Turkey";
		$country_codes["tt"] = "Trinidad and Tobago";
		$country_codes["tv"] = "Tuvalu";
		$country_codes["tw"] = "Taiwan";
		$country_codes["tz"] = "Tanzania";
		$country_codes["ua"] = "Ukraine";
		$country_codes["ug"] = "Uganda";
		$country_codes["uk"] = "United Kingdom";
		$country_codes["um"] = "U.S. Minor Outlying Islands";
		$country_codes["us"] = "United States";
		$country_codes["uy"] = "Uruguay";
		$country_codes["uz"] = "Uzbekistan";
		$country_codes["va"] = "Vatican City State";
		$country_codes["vc"] = "Saint Vincent & Grenadines";
		$country_codes["ve"] = "Venezuela";
		$country_codes["vg"] = "British Virgin Islands";
		$country_codes["vi"] = "U.S. Virgin Islands";
		$country_codes["vn"] = "Vietnam";
		$country_codes["vu"] = "Vanuatu";
		$country_codes["wf"] = "Wallis and Futuna Islands";
		$country_codes["ws"] = "Samoa";
		$country_codes["ye"] = "Yemen";
		$country_codes["yt"] = "Mayotte";
		$country_codes["yu"] = "Yugoslavia";
		$country_codes["za"] = "South Africa";
		$country_codes["zm"] = "Zambia";
		$country_codes["zw"] = "Zimbabwe";
	
		country_codes_reversed = new Array();
		for (country_code in $country_codes) {
			country_codes_reversed[$country_codes[country_code]] = country_code;
		}
		
	
// read in a preferences (.ini) file if one exists, and show which preferences may be overridden from the URL string

	$preferences = get_file_simple("../data/preferences.ini");
	if ($preferences) {
		//$URL_rewriting_flag = get_setting($preferences, "URL rewriting flag", 1, 1);
		$top_n = get_setting($preferences, "top n", 1, 1);
		$graph_image = get_setting($preferences, "graph image", 1, 1);
		$graph_color = get_setting($preferences, "graph color", 1, 1);
		$update_interval = get_setting($preferences, "real-time update interval", 1, 1);
		$maximum_column_width = get_setting($preferences, "column width", 1, 1);
		$show_inspector_rollover = get_setting($preferences, "inspector rollover", 1, 1);
		$one_big_page = get_setting($preferences, "one big page", 1, 1);
		$exclude_from_hosts = get_setting($preferences, "exclude traffic", 1, 1);
		$track_visitors = get_setting($preferences, "track visitors", 1, 1);
		$visit_expires = get_setting($preferences, "visit expires", 1, 1);
	} else {
		//$URL_rewriting_flag = "";
		$top_n = "";
		$graph_color = "";
		$graph_image = "";
		$update_interval = "";
		$maximum_column_width = "";
		$show_inspector_rollover = "";
		$one_big_page = "";
		$exclude_from_hosts = "";
		$track_visitors = "";
		$visit_expires = "";
	}
	

// do a bit of processing on the settings, and set some defaults in case preferences.ini or individual settings are absent

	//if ($URL_rewriting_flag == "") { $URL_rewriting_flag = "assembled"; }

	if ($top_n === "") { $top_n = 5; }

	if ($graph_color === "") { $graph_color = "0000FF"; } // Flash does not use # to denote a hex value
	$graph_color = $graph_color.replace("#", ""); // Flash doesn't use # to denote a hex value

	if ($graph_image === "") { $graph_image = "../graphics/logo.jpg"; }
	$graph_image = "../" + $graph_image; // make the path relative to the Flash file, which is in a subdirectory of the Contemplate directory
	$graph_image = $graph_image.replace("../../", "%252E%252E%252F%252E%252E%252F"); // double-encode the up delimiter to prevent Mac IE from decoding and then rewriting it
	
	if ($update_interval === "") { $update_interval = 30; }

	if ($maximum_column_width === "") { $maximum_column_width = 64; }

	// this is eye candy that probably slows down page rendering somewhat
	if ($show_inspector_rollover === "") { $show_inspector_rollover = 1; }
	$show_inspector_rollover = parseFloat($show_inspector_rollover);

	// this shows the full data for each section on the same page as the top $top_n
	if ($one_big_page === "") { $one_big_page = 0; }
	$one_big_page = parseFloat($one_big_page);
	
	if ($exclude_from_hosts) {
		$exclude_from_hosts = $exclude_from_hosts.replace(/, /g, ",");
		$exclude_from_hosts = $exclude_from_hosts.split(",");
		$exclude_from_hosts_count = $exclude_from_hosts.length;
	}

	if ($track_visitors === "") { $track_visitors = "0"; }
	$track_visitors = parseFloat($track_visitors);
	if (!$track_visitors) {
		// remove the visitors elements from our arrays if we're not using them
		$columns.splice(1, 1);
		$columns_errors.splice(1, 1);
		$sections.splice(3, 3);
		$sections_display.splice(3, 3);
	}

	if ($visit_expires === "") { $visit_expires = 30; }


//  if requested, delete the error log

	if ($clear) {
		FSO = Server.CreateObject("Scripting.FileSystemObject");
		if (FSO.FileExists($error_file)) {
			FSO.DeleteFile($error_file);
		}
		FSO = "";
	}


// if called from the real-time Flash viewer, provide some data for that

	if ($realtime) {
	
		// reinitialize $data_file to use the current month rather than looking in the URL string for a month
		$year = String($JScript_date.getFullYear());
		$month = String($JScript_date.getMonth() + 1);
		if ($month < 10) { $month = "0" + $month; }
		$data_file = $year + "-" + $month + ".txt";
		$data_file_text = $data_file;
		$data_file = $data_directory + $data_file;
	
		// open the log file
		$text = get_file_simple($data_file);
	
		// create an array from the lines in the file
		$text = $text.split("\r");		
	
		// loop through the array and count the number of lines that contain the appropriate number of columns	
		$page_views_total = 0;
		for ($line_index=0; $line_index < $text.length; $line_index++) {
			$next = $text[$line_index].split("\t");
			if ($next.length == $columns.length) {
				$page_views_total++;
			}
		}
		
		// grab just the last ten lines to pass back to the Flash viewer
		if ($text.length > 10) {
			$tail = $text.slice(-10);
		}
				
		// process those lines a bit before passing them on
		for ($line_index=0; $line_index < $tail.length; $line_index++) {
			$next = $tail[$line_index].split("\t");

			// add the country code to each line	
			$host = ($track_visitors) ? $next[3] : $next[2] ;
			$re = /\.([^\.\d]+)$/; $matches = $host.match($re);
			if ($matches) {
				$next.push($country_codes[$matches[1]]);
			} else {
				$next.push($blank_marker);
			}
			
			// remove the visitor ID so the Flash viewer doesn't have to worry about it
			if ($track_visitors) {
				$next.splice(1, 1);
			}
			
			$tail[$line_index] = $next.join("\t");
		}
				
		// finally, print the results out for the Flash viewer to read
		$tail = Server.urlencode($tail.join("\n"));
		Response.write("hits=" + $page_views_total + "&data_file=" + $data_file_text + "&tail=" + $tail);	
		
		Response.end();
	
	}


//  set up the HTML page

	Response.Write("<html>\r");
	Response.Write("<head>\r");
	Response.Write("<title>Contemplate(tm) Web Templating System</title>\r");
	Response.Write("<link rel=stylesheet href=../stylesheet.css type=text/css>\r");
	Response.Write("</head>\r");
	Response.Write("<body bgcolor=#FFFFFF>\r");
	Response.Write("<p class=title>Contemplate</p>\r");
	Response.Write("<p class=body><a href=../index.html>Utilities menu</a> &gt; Reporter</p>\r");
	Response.Write("<div class=body>\r");
	Response.Flush();
	
	if ($show_performance) {
		$JScript_date = new Date();
		$this_performance_time = $JScript_date.getSeconds();
		$performance_times += "&nbsp;&nbsp;script and page setup - " + ($this_performance_time - $last_performance_time) + " seconds<br>\r";
		$total_performance_time = $total_performance_time + ($this_performance_time - $last_performance_time);
		$last_performance_time = $this_performance_time;
	}
	

// if an inspect key is provided, focus on a cross-section of the month's report

	if ($inspector_key) {


	// don't display the entry and exit page values on the inspector page

		$sections.splice(3, 2);
		$sections_display.splice(3, 2);
	

	// read the data file for the current month and save the lines that match the inspect value
	
		$text = get_file_simple($data_file);
		if ($text.indexOf("(visitors not tracked)") != -1) {
			// don't display the visitor values if we encounter a file that predates that functionality
			$sections.splice(3, 1);
			$sections_display.splice(3, 1);
		}
		$text = $text.split("\r")
		$lines = new Array();

		// first, make a list of the lines we want to display
		// we'll do this differently for entry and exit pages because we want to show them with their corresponding visit pages
		if (($inspector_key != "entry_pages")&&($inspector_key != "exit_pages")) {

			// it's nice for users to pass in the column name as the inspect key, but the column index is more useful to us
			if ($inspector_key == "countries") {
				// countries is really just a part of the host value
				$inspector_key_index = 3;
			} else {
				for ($i=0; $i<$columns.length; $i++) {
					if ($inspector_key == $columns[$i]) { $inspector_key_index = $i; }
				}
			}
			
			for ($line_index=0; $line_index<$text.length; $line_index++) {
				$text[$line_index] = $text[$line_index].replace(/\\/g, "\\\\"); // a backslash at the end of a line causes problems, so remove those
				$next = $text[$line_index].split("\t");
				if ($next.length == $columns.length) { // make sure the line has all the elements we're expecting it to have
	
					// dates have to start with value, country codes have to end with value, all others have to equal value
					$match_end = ($inspector_key == "dates") ? ".*" : "" ;
					$match_start = ($inspector_key == "countries") ? ".*" : "" ;
					$re = new RegExp("^" + $match_start + regex_quote(String($inspector_value)) + $match_end + "$", "");
					if ($re.test($next[$inspector_key_index])) {
						$lines.push($line_index);
					}
					
				}
			}
			
		} else {

			// we're going to make a $visits array that's an array of dates, each of which is in turn an array of line numbers from the data file
			$visits = new Array();
			
			for ($line_index=0; $line_index<$text.length; $line_index++) {
				$text[$line_index] = $text[$line_index].replace(/\\/g, "\\\\"); // a backslash at the end of a line causes problems, so remove those
				$next = $text[$line_index].split("\t");
				if ($next.length == $columns.length) { // make sure the line has all the elements we're expecting it to have
	
					// extract the date and visitor values out of the log entry
					$this_dates = $next[0];
					$this_visitors = $next[1];

					// don't track this at all if the visitor ID is missing (e.g. the client didn't accept the cookie)
					if (!$this_visitors) {
						$page_views--;
					} else {
					
						if (!$visits[$this_visitors]) {
							// if we haven't encountered this visitor yet, add a new visit entry with this date and line number
							$visits[$this_visitors] = new Array();
							$visits[$this_visitors][$this_dates] = new Array();
							$visits[$this_visitors][$this_dates].push($line_index);
							//Response.write("line " + $line_index + ": adding visitor " + $this_visitors + " (" + $visits[$this_visitors][$this_dates].join(",") + ")<br>"); // debug
						} else {
							// if we have encountered this visitor already, check the last page view to see if this is part of the same visit
							for ($last_date in $visits[$this_visitors]) { } // this gets the last key in the associative array
							$interval = (get_unix_time($this_dates) - get_unix_time($last_date));
							if ($interval < ($visit_expires * 60)) {
								// if the last page view was less than $visit_expires minutes ago, add this line number to the latest visit array
								$visits[$this_visitors][$last_date].push($line_index);
								//Response.write("line " + $line_index + ": updating visit " + $last_date + " (" + $visits[$this_visitors][$last_date].join(",") + ")<br>"); // debug
							} else {	
								// otherwise, make a new visit array for this line number
								$visits[$this_visitors][$this_dates] = new Array();
								$visits[$this_visitors][$this_dates].push($line_index);
								//Response.write("line " + $line_index + ": adding visit " + $this_dates + " (" + $visits[$this_visitors][$this_dates].join(",") + ")<br>"); // debug
							}
						}
					
					}

				}
			}

			// now filter and sort our multidimensional $visits array and flatten it into a one-dimensional $lines array
			// note that JScript's for loop returns the key, not the value, so this is a bit different than the other languages
			$visits_flattened = new Array();
			$lines = Array();
			for ($visitor in $visits) {
				for ($date in $visits[$visitor]) {
					$entry_line_index = $visits[$visitor][$date][0];
					$exit_line_index = $visits[$visitor][$date][$visits[$visitor][$date].length - 1];
					$entry_line = $text[$entry_line_index].split("\t");
					$exit_line = $text[$exit_line_index].split("\t");
					$entry_page = $entry_line[4];
					$exit_page = $exit_line[4];
					if ( (($inspector_key == "entry_pages")&&($inspector_value == $entry_page)) || (($inspector_key == "exit_pages")&&($inspector_value == $exit_page)) ) {
						$visits_flattened[$date + " " + $visitor] = $visits[$visitor][$date];
					}
				}
			}
			$visits_flattened = $visits_flattened.sort();
			for ($visit in $visits_flattened) {
				for ($line_index in $visits_flattened[$visit]) {
					$lines.push($visits_flattened[$visit][$line_index]);
				}
			}
					
		}
		
		// then, loop through the array of line indexes we created and prepare the selected lines for display
		for ($line_index=0; $line_index<$lines.length; $line_index++) {
			$text[$lines[$line_index]] = $text[$lines[$line_index]].replace(/\\/g, "\\\\"); // a backslash at the end of a line causes problems, so remove those
			$next = $text[$lines[$line_index]].split("\t");
			//Response.write("displaying line " + $lines[$line_index] + "<br>"); // debug

			// extract the values out of the log entry
			for ($i=0; $i < $columns.length; $i++) {
				eval("$this_" + $columns[$i] + " = ($next[$i] != '') ? $next[$i] : $blank_marker ");
			}
		
			// check the host and skip this line if it matches our exclude hosts
			$include_this_host = 1;
			if ($exclude_from_hosts) {
				for ($i=0; $i < $exclude_from_hosts_count; $i++) {
					$re = new RegExp($exclude_from_hosts[$i], "i");
					if ($re.test($this_hosts)) { $include_this_host = 0; }
				}
			}

			if ($include_this_host) {
				// clean up some of the values
				// - display visitor ID as a user agent and timestamp if the timestamp is present
				$re = /\w+-(\d\d\d\d)(\d\d)(\d\d)(\d\d)(\d\d)(\d\d)/;
				if ($re.test($this_visitors)) {
					$this_visitors_display = RegExp.$1 + "-" + RegExp.$2 + "-" + RegExp.$3 + " " + RegExp.$4 + ":" + RegExp.$5 + ":" + RegExp.$6;
					$this_user_agents_display = $this_user_agents;
					$re2 = /.+\)(.+)/;
					if ($re2.test($this_user_agents_display)) {
						$this_user_agents_display = RegExp.$1; // if there is a parenthesis, just take the text after the parenthesis
					}
					$this_user_agents_display = $this_user_agents_display.replace("compatible; ", "");
					$this_user_agents_display = ($this_user_agents_display.length > ($maximum_column_width - 22)) ? ($this_user_agents_display.substr(0, $maximum_column_width - 25) + "...") : $this_user_agents_display ;
					$this_visitors = $this_user_agents_display + " (" + $this_visitors_display + ")";
				}
				// - convert TLD to country code
				$re = /\.([^\.]+)$/;
				if ($re.test($this_hosts)) {
					$TLD = RegExp.$1.toLowerCase();
					$this_countries = $country_codes[$TLD];
				} else {
					$this_countries = $blank_marker;
				}
					
				// then assemble the values back into a new array
				eval("$line_" + $line_index + " = new Array()");
				for ($i=0; $i < $sections.length; $i++) {
					eval("$line_" + $line_index + "[$i] = $this_" + $sections[$i]);
				}
			}
		
		}
		

	// print the matching lines in a table

		$output = $output + "<p class=heading><a name=top>Traffic for " + month_display($month) + "</a></p>\r";
		
		$inspector_key_singular = $inspector_key.substr(0, $inspector_key.length - 1);
		if ($inspector_key_singular == "IP addresse") { $inspector_key_singular = $inspector_key_singular.substr(0, $inspector_key_singular.length - 1); }
		if ($inspector_key_singular == "countrie") { $inspector_key_singular = "country"; }
		$output = $output + "<b>Where " + $inspector_key_singular + " contains " + $inspector_value + "</b><br>\r";
		$output = $output + "<b>Total page views: " + $lines.length + "</b><p>\r\r";
		
		$output = $output + "&lt;&ndash; <a href=JavaScript:history.back()>" + $back_label + "</a><p>\r\r";

		$output = $output + "<table cellpadding=2 cellspacing=0 border=0>\r\r";
		
		$output = $output + "<tr bgcolor=#CCCCCC>\r";
		for ($i=0; $i < $sections.length; $i++) {
			$output = $output + "<td class=subheading>" + ucfirst($sections[$i]) + "</td>\r";
		}
		$output = $output + "</tr>\r\r";
	
		for ($line_index=0; $line_index < $lines.length; $line_index++) {	
			eval("$this_line_array = $line_" + $line_index);

			// draw a dividing line if we're about to start displaying a new visit (for entry pages and exit pages only)
			if (($inspector_key == "visitors")||($inspector_key == "entry_pages")||($inspector_key == "exit_pages")) {
				$this_dates = $this_line_array[0];
				$this_visitors = $this_line_array[3];
				if ($line_index > 0) {
					if (($this_visitors != $last_visitor)||(get_unix_time($this_dates) - get_unix_time($last_date)) > ($visit_expires * 60)) {
						$output += "<tr valign=top><td colspan=" + $sections.length + "><hr></td></tr>\r";
					}
				}
				$last_date = $this_dates;
				$last_visitor = $this_visitors;
			}

			$output = $output + "<tr valign=top>\r";
			for ($i=0; $i < $sections.length; $i++) {
				$key = $this_line_array[$i];
				
				// break the line after a predetermined number of characters
				$key_complete = $key;
				$key = ($key.length > $maximum_column_width) ? wordwrap($key, $maximum_column_width, "<br>", 1) : $key ;
				
				// make the page items into a link
				if ($sections[$i] == "pages") {
					$key = ($key != $blank_marker) ? ("<a href=../assembler.asp?page=" + $key_complete + " target='_new'>" + $key + "</a>") : $key ;
				}
				
				// make the IP address items into a link
				if ($sections[$i] == "IP_addresses") {
					$key = ($key != $blank_marker) ? ("<a href=http://ws.arin.net/cgi-bin/whois.pl?queryinput=" + $key_complete + " target='_new'>" + $key + "</a>") : $key ;
				}
				
				// make the referrer items into a link
				if ($sections[$i] == "referrers") {
					$key = ($key != $blank_marker) ? ("<a href=" + $key_complete + " target='_new'>" + $key + "</a>") : $key ;
				}

				$output = $output + "<td class=body>\r" + $key + "\r</td>\r";
			}
			$output = $output + "</tr>\r\r";
		}
		
		$output = $output + "</table><p>\r\r";
	
		$output = $output + "&lt;&ndash; <a href=JavaScript:history.back()>" + $back_label + "</a><p>\r\r";


//  if a month is specified, display that month's report

	} else if ($month) {
	
	
	// read the data file
	
		$text = get_file_simple($data_file);
		if ($text.indexOf("(visitors not tracked)") != -1) {
			// don't display the entry page, exit page, or visitor values if we encounter a file that predates that functionality
			$sections.splice(3, 3);
			$sections_display.splice(3, 3);
		}
		
		if ($show_performance) {
			$JScript_date = new Date();
			$this_performance_time = $JScript_date.getSeconds();
			$performance_times += "&nbsp;&nbsp;load data file - " + ($this_performance_time - $last_performance_time) + " seconds <br>\r";
			$total_performance_time = $total_performance_time + ($this_performance_time - $last_performance_time);
			$last_performance_time = $this_performance_time;
		}


	// split the data into lines and columns and create associative arrays

		$page_views_total = 0; // a simple count will do here
		$visits = new Array(); // but here we have to remember each visit to avoid duplicates
		$exit_pages_maybe = new Array();
		$text = $text.split("\r")
		if ($show_performance) {
			$JScript_date = new Date();
			$this_performance_time = $JScript_date.getSeconds();
			$performance_times += "&nbsp;&nbsp;split data file - " + ($this_performance_time - $last_performance_time) + " seconds <br>\r";
			$total_performance_time = $total_performance_time + ($this_performance_time - $last_performance_time);
			$last_performance_time = $this_performance_time;
		}
		for ($line_index=0; $line_index<$text.length; $line_index++) {
			$text[$line_index] = $text[$line_index].replace(/\\/g, "\\\\"); // a backslash at the end of a line causes problems, so remove those
			$next = $text[$line_index].split("\t");
			if ($next.length == $columns.length) { // make sure the line has all the elements we're expecting it to have

				// extract the values out of the log entry
				for ($i=0; $i < $columns.length; $i++) {
					eval("$this_" + $columns[$i] + " = ($next[$i] != '') ? $next[$i] : $blank_marker ");
				}
			
				// check the host and skip this line if it matches our exclude hosts
				$include_this_host = 1;
				if ($exclude_from_hosts) {
					for ($i=0; $i < $exclude_from_hosts_count; $i++) {
						$re = new RegExp($exclude_from_hosts[$i], "i");
						if ($re.test($this_hosts)) { $include_this_host = 0; }
					}
				}

				if ($include_this_host) {
					// clean up some of the values
					// - ignore times to group page views by day
					$this_dates = $this_dates.substr(0, $this_dates.indexOf(" "));
					// - display visitor ID as a user agent and timestamp if the timestamp is present
					$re = /\w+-(\d\d\d\d)(\d\d)(\d\d)(\d\d)(\d\d)(\d\d)/;
					if ($re.test($this_visitors)) {
						$this_visitors_display = RegExp.$1 + "-" + RegExp.$2 + "-" + RegExp.$3 + " " + RegExp.$4 + ":" + RegExp.$5 + ":" + RegExp.$6;
						$this_user_agents_display = $this_user_agents;
						$re2 = /.+\)(.+)/;
						if ($re2.test($this_user_agents_display)) {
							$this_user_agents_display = RegExp.$1; // if there is a parenthesis, just take the text after the parenthesis
						}
						$this_user_agents_display = $this_user_agents_display.replace("compatible; ", "");
						$this_user_agents_display = ($this_user_agents_display.length > ($maximum_column_width - 22)) ? ($this_user_agents_display.substr(0, $maximum_column_width - 25) + "...") : $this_user_agents_display ;
						$this_visitors = $this_user_agents_display + " (" + $this_visitors_display + ") " + $this_visitors; // we're adding the original visitors value temporarily so that we can grab it later to build the inspector
					}
					// - convert TLD to country code
					$re = /\.([^\.]+)$/;
					if ($re.test($this_hosts)) {
						$TLD = RegExp.$1.toLowerCase();
						$this_countries = $country_codes[$TLD];
					} else {
						$this_countries = $blank_marker;
					}
					// - filter self-referrers
					if (($this_referrers == $my_domain)||($this_referrers.length < 3)) { $this_referrers = $blank_marker; }
						
					// look for entry and exit pages, which requires keeping track of visits (page views by a visitor with no more than a $visit_expires minutes delay between them)
					if ($track_visitors) {
						$this_entry_pages = "";
						$this_exit_pages = "";
						if (!$visits[$this_visitors]) {
							// add a new visit entry with this time
							$visits[$this_visitors] = $this_dates; // we're identifying visits by the visitor ID and date
							// set this page as an entry page
							$this_entry_pages = $this_pages;
							// also hold onto it as a possible exit page (we won't know until we reach the end of the file whether it's really the exit page)
							$exit_pages_maybe[$this_visitors] = $this_pages;
						} else {
							$last_dates = $visits[$this_visitors];
							$interval = (get_unix_time($this_dates) - get_unix_time($last_dates));
							if ($interval < ($visit_expires * 60)) {
								// if the last page view was less than $visit_expires minutes ago, update the visit entry with the time of this latest page view
								$visits[$this_visitors] = $this_dates;
								// also update the possible exit page for this visit
								$exit_pages_maybe[$this_visitors] = $this_pages;
							} else {	
								// otherwise, tag the old visit entry with the end time for that visit and add a new visit entry with this new time
								$visits[$this_visitors + " " + $last_dates] = $last_dates;
								$visits[$this_visitors] = $this_dates;
								// set this page as an entry page
								$this_entry_pages = $this_pages;
								// move the last page for this visitor from the maybe list to the definite list, then add this page to the maybe list to start the cycle again
								$this_exit_pages = $exit_pages_maybe[$this_visitors];
								$exit_pages_maybe[$this_visitors] = $this_pages;
							}
						}
					}

					// then add each value to the appropriate array
					for ($i=0; $i < $sections.length; $i++) {
						eval("$isnotempty = ($this_" + $sections[$i] + " + '')"); // e.g. if ($this_dates)
						if ($isnotempty) {
							eval("$isset = ($" + $sections[$i] + "[$this_" + $sections[$i] + "] + '' != 'undefined')"); // e.g. if ($dates["2003-05"]) != 'undefined')
							if ($isset) {
								eval("$" + $sections[$i] + "[$this_" + $sections[$i] + "]++");
								eval("$this_page_views = $" + $sections[$i] + "[$this_" + $sections[$i] + "]");
								if ($this_page_views > $page_views_greatest) { $page_views_greatest = $this_page_views; }
							} else {
								eval("$" + $sections[$i] + "[$this_" + $sections[$i] + "] = 1");
							}
						}
					}
			
					$page_views_total++;
				}
				
			}
		}
		
		// now that we're at the end of the file, any remaining pages in the maybe list are definitely exit pages
		for ($this_visitors in $exit_pages_maybe) {
			$this_exit_pages = $exit_pages_maybe[$this_visitors]; // apparently the for loop gives back the keys, not the values
			if ($this_exit_pages) {
				if ($exit_pages[$this_exit_pages] + "" != "undefined") {
					$exit_pages[$this_exit_pages]++;
					$this_page_views = $exit_pages[$this_exit_pages];
					if ($this_page_views > $page_views_greatest) { $page_views_greatest = $this_page_views; }
				} else {
					$exit_pages[$this_exit_pages] = 1;
				}
			}
		}

		if ($show_performance) {
			$JScript_date = new Date();
			$this_performance_time = $JScript_date.getSeconds();
			$performance_times += "&nbsp;&nbsp;process data file - " + ($this_performance_time - $last_performance_time) + " seconds <br>\r";
			$total_performance_time = $total_performance_time + ($this_performance_time - $last_performance_time);
			$last_performance_time = $this_performance_time;
		}

		
	// print the reports in a table
		
		$output += "<p class=heading><a name=top>Traffic for " + month_display($month) + "</a></p>\r\r";
		
		$output += "<p class=subheading>Total page views: " + $page_views_total + "</p><br>\r\r";
		
		$output += "<p class=body>\r";
		$output += "<a href=reporter.asp>Months</a> &gt; \r";
		if (($section)&&(!$one_big_page)) {
			$output += "<a href=reporter.asp?month=" + $month + ">Top " + $top_n + "'s</a> &gt; \r";
		} else {
			$output += "Top " + $top_n + "'s &gt; \r";
		}
		$output += "<font color=#0000FF>All</font> ";
		for ($i=0; $i < $sections.length; $i++) {
			$link = ($one_big_page) ? ("#" + $sections[$i]) : ("reporter.asp?month=" + $month + "&section=" + $sections[$i]);
			if ($section == $sections[$i]) {
				$output += ucfirst($sections_display[$i]) + ", ";
			} else {
				$output += "<a href=" + $link + ">" + ucfirst($sections_display[$i]) + "</a>, ";
			}
		}
		
		if ($section == "errors_HTTP") {
			$output += "HTTP errors, ";
		} else {
			if ($one_big_page) {
				$output += "<a href=#errors_HTTP>HTTP errors</a>, ";
			} else {
				$output += "<a href=reporter.asp?month=" + $month + "&section=errors_HTTP>HTTP errors</a>, ";
			}
		}
		if ($section == "errors_assembler") {
			$output += "Assembler errors<p>";
		} else {
			if ($one_big_page) {
				$output += "<a href=#errors_assembler>Assembler errors</a>\r";
			} else {
				$output += "<a href=reporter.asp?month=" + $month + "&section=errors_assembler>Assembler errors</a>\r";
			}
		}
		$output += "</p>\r\r";
		
		$inspector_button_ID = 0;
			
		$output += "<table cellpadding=2 cellspacing=0 border=0>\r\r";
		
		if ($show_performance) {
			$JScript_date = new Date();
			$this_performance_time = $JScript_date.getSeconds();
			$performance_times += "&nbsp;&nbsp;set up section links - " + ($this_performance_time - $last_performance_time) + " seconds <br>\r";
			$total_performance_time = $total_performance_time + ($this_performance_time - $last_performance_time);
			$last_performance_time = $this_performance_time;
		}

		$passes = 2;
		for ($h=0; $h < $passes; $h++) { // print all the tables twice, the first time showing just the top $top_n ...
		
			// ... but if we're splitting the sections up, skip the first or second pass
			if (!$one_big_page) {
				if (!$section) {
					$passes = 1; // only do the first part
				} else {
					$h = 1; // only do the second part
				}
			}
			
			for ($i=0; $i < $sections.length; $i++) {
				
				// skip unless we're displaying this section, or no section is specified
				
				if ((!$section) || ($section == $sections[$i])) {
			
					if ($h == 0) {
						$label = "Top " + $top_n + " " + $sections_display[$i];
						$button_link = ($one_big_page) ? ("#" + $sections[$i]) : ("reporter.asp?month=" + $month + "&section=" + $sections[$i]) ;
						$button = "<a href=" + $button_link + ">All " + $sections_display[$i] + "</a>";
						$space_after = 18;
					} else {
						$label = "<a name='" + $sections[$i] + "'>All " + $sections_display[$i] + "</a>";
						if ($one_big_page) { $button = "<a href=#top>Top</a>"; }
						$space_after = 36;
					}
	
					$output += "<tr><td colspan=6 bgcolor=#CCCCCC class=subheading><img src=../graphics/spacer.gif height=2 width=1><br>" + $label + "</td></tr>\r\r";
					
					// sort the full dates list by key and everything else by value
					if (($sections[$i] == "dates")&&($h == 1)) {
						eval("$this_section_array = $" + $sections[$i]);
						$this_section_array = $this_section_array.sort();
						$this_section_keys = new Array();
						//$this_section_values = new Array();
						for ($key in $this_section_array) {
							$this_section_keys.push($key);
							//$this_section_values.push($this_section_array[$key]);
						}
					} else {
						// JScript can't sort associative arrays, so we have to flatten this into a regular array with the value first, sort that, then split it up again
						eval("$this_section_array = $" + $sections[$i]);
						$this_section_array_flattened = new Array();
						for ($key in $this_section_array) {
							$value = $this_section_array[$key];
							$this_section_array_flattened.push($value + " :: " + $key);
						}
						
						function sort_descending (a,b) { return ( (parseFloat(a)>parseFloat(b)) ? -1 : ( (parseFloat(a)<parseFloat(b)) ? 1 : 0 ) ) }
						$this_section_array_flattened.sort(sort_descending);					
						
						$this_section_keys = new Array();
						//$this_section_values = new Array();
						for ($j=0; $j<$this_section_array_flattened.length; $j++) {
							$this_pair = $this_section_array_flattened[$j].split(" :: ");
							$this_section_keys.push($this_pair[1]);
							//$this_section_values.push($this_pair[0]);
						}
					}
					
					// for the partial list, crop to the first $top_n values
					if ($h == 0) {
						$this_section_keys.splice($top_n, $this_section_keys.length);
						//$this_section_values.splice($top_n, $this_section_values.length);
					}
						
					if ($show_performance) {
						$JScript_date = new Date();
						$this_performance_time = $JScript_date.getSeconds();
						$performance_times += "&nbsp;&nbsp;sort and crop " + $sections[$i] + " data - " + ($this_performance_time - $last_performance_time) + " seconds <br>\r";
						$total_performance_time = $total_performance_time + ($this_performance_time - $last_performance_time);
						$last_performance_time = $this_performance_time;
					}

					// okay, now we can finally print the rows
					$this_limit = ($this_section_keys.length < $top_n) ? $this_section_keys.length : $top_n ;
					$keys_count = ($h > 0) ? $this_section_keys.length : $this_limit ;
					
					for ($j=0; $j < $keys_count; $j++) {
						
						$key = $this_section_keys[$j];
						//$value = $this_section_values[$j];
						eval("$value = $" + $sections[$i] + "[$key]");
																		
						$inspector_key = $sections[$i];
						$inspector_value = $key;
						
						// separate the original value from the display value for the inspect script
						if ($sections[$i] == "visitors") {
							if ($inspector_value.indexOf(") ") != -1) {
								$key = $inspector_value.substr(0, $inspector_value.indexOf(") ") + 1);
								$inspector_value = $inspector_value.substr($inspector_value.indexOf(") ") + 2);
							}
						}
						
						// untranslate the country code for the inspect script
						if ($sections[$i] == "countries") {
							if (($inspector_value != "")&&($inspector_value != $blank_marker)) {
								$inspector_value = "." + eval("country_codes_reversed[\"" + $inspector_value + "\"]");
							}
						}
						
						// do some basic URL-encoding on the inspect value
						$inspector_key = Server.urlencode($inspector_key);
						$inspector_value = Server.urlencode($inspector_value);
												
						// limit the item display length to a predetermined number of characters
						$key_complete = $key;
						$key = ($key.length > $maximum_column_width) ? ($key.substr(0, $maximum_column_width) + "...") : $key ;
						
						// make the page items into a link
						if ($sections[$i] == "pages") {
							$key = ($key != $blank_marker) ? ("<a href=../assembler.asp?page=" + $key_complete + " target='_new'>" + $key + "</a>") : $key ;
						}

						// make the IP address items into a link
						if ($sections[$i] == "IP_addresses") {
							$key = ($key != $blank_marker) ? ("<a href=http://ws.arin.net/cgi-bin/whois.pl?queryinput=" + $key_complete + " target='_new'>" + $key + "</a>") : $key ;
						}
						
						// make the referrer items into a link
						if ($sections[$i] == "referrers") {
							$key = ($key != $blank_marker) ? ("<a href=" + $key_complete + " target='_new'>" + $key + "</a>") : $key ;
						}
						
						// provide a link for seeing all the fields for a particular item
						$back_label = ($section) ? ("All " + $section) : ("Top " + $top_n + "%27s") ;
						$back_label = $back_label.replace("_"," ");
						$back_label = $back_label.replace(" ", "%20");
						if ($show_inspector_rollover) {
							$inspector_link = ($key != $blank_marker) ? ("<a href='reporter.asp?month=" + $month + "&inspector_key=" + $inspector_key + "&inspector_value=" + $inspector_value + "&back_label=" + $back_label + "'><img src=../graphics/inspector_0.gif onmouseover='document.images.inspector_" + $inspector_button_ID + ".src=\"../graphics/inspector_1.gif\"' onmouseout='document.images.inspector_" + $inspector_button_ID + ".src=\"../graphics/inspector_0.gif\"' width=12 height=12 border=0 name=inspector_" + $inspector_button_ID + " alt='Inspect'></a>") : "&nbsp;" ;
							$inspector_button_ID++;
						} else {
							$inspector_link = ($key != $blank_marker) ? ("<a href='reporter.asp?month=" + $month + "&inspector_key=" + $inspector_key + "&inspector_value=" + $inspector_value + "&back_label=" + $back_label + "'><img src=../graphics/inspector_0.gif width=12 height=12 border=0 alt='Inspect'></a>") : "&nbsp;" ;
						}
						
						$output += "<tr valign=top><td class=body>\r";
						$output += $inspector_link + "&nbsp;";
						$output += "</td>\n<td class=body>\r";
						$output += $key;
						$output += "</td>\n<td align=right><img src=../graphics/spacer.gif width=12 height=1></td>\n<td class=body>\r";
						$output += $value;
						$output += "</td>\n<td align=right><img src=../graphics/spacer.gif width=12 height=1></td>\n<td width=" + $graph_width + ">\r";
						$output += "<font color=" + random_color() + "><img src=../graphics/spacer.gif height=4 width=" + (($value / $page_views_greatest) * $graph_width) + " border=1></font>\r";
						$output += "</td></tr>\r\r";
						
					}
						
					// more/top buttons after listings
					$output += "<tr><td colspan=6 class=body>" + $button + "</td></tr>\r\r";
					
					// space between rows
					if (!$section) { $output += "<tr><td colspan=6><img src=../graphics/spacer.gif height=" + $space_after + " width=1></td></tr>\r\r"; }
					
					if ($show_performance) {
						$JScript_date = new Date();
						$this_performance_time = $JScript_date.getSeconds();
						$performance_times += "&nbsp;&nbsp;print " + $sections[$i] + " data - " + ($this_performance_time - $last_performance_time) + " seconds <br>\r";
						$total_performance_time = $total_performance_time + ($this_performance_time - $last_performance_time);
						$last_performance_time = $this_performance_time;
					}

				}
				
			}
			
			
			// space between sections
			if ($h == 0) {
				if ($one_big_page) { $output += "<tr><td colspan=6><img src=../graphics/spacer.gif height=36 width=1></td></tr>\r\r"; }
			}				
			
		}
		
		
// look for an error file and print those, too
		
		// skip if this is the menu and we're splitting the sections up
		if (($one_big_page)||($section)) {
			for ($h=0; $h<2; $h++) {
				
				$error_type = ($h == 0) ? "HTTP" : "assembler";
				
				// skip unless we're displaying this section, or no section is specified
				if ((!$section)||($section == "errors_" + $error_type)) {
					
					$error_list = "";

					$output += "<tr><td colspan=6 bgcolor=#CCCCCC class=subheading><img src=../graphics/spacer.gif height=2 width=1><br><a name='errors_" + $error_type + "'>All " + $error_type + " errors</a></td></tr>\r\r";

					$text = get_file_simple($error_file);
					
					if ($text.indexOf("Error: ") != 0) {
						$text = $text.split("\r");
						for ($line_index=0; $line_index<$text.length; $line_index++) {
							$text[$line_index] = $text[$line_index].replace(/\\/g, "\\\\"); // a backslash at the end of a line causes problems, so remove those
							$next = $text[$line_index].split("\t");
							if ($next.length == $columns_errors.length) { // make sure the line has all the elements we're expecting it to have
							
								// extract the values out of the log entry
								for ($i=0; $i < $columns_errors.length; $i++) {
									eval("$this_" + $columns_errors[$i] + " = ($next[$i] != '') ? $next[$i] : $blank_marker ");
								}
				
								// clean up some of the values
								$this_pages = ($this_pages.length > ($maximum_column_width + 24)) ? ($this_pages.substr(0, ($maximum_column_width + 24)) + "...") : $this_pages ; // limit the page display length
								
								$re = /\d\d\d/;
								if (($error_type == "assembler")&&(!$re.test($this_message.substr(0, 3)))&&($this_message.substr(0, 3) != "Unk")) {
									// show assembler errors first...
									$this_message = $this_message.replace(",", "<br>");
									$error_list += "<tr><td colspan=6 class=body>" + $this_dates + "<br>" + $this_pages + "<br>" + $this_message + "<hr></td></tr>\r";
								} else if (($error_type == "HTTP")&&($re.test($this_message.substr(0, 3)))||($this_message.substr(0, 3) == "Unk")) {
									// ...then HTTP errors
									$this_message = $this_message.replace(/[^\d]/g,""); // strip it down to just the error code
									$this_message = ($HTTP_error_codes[$this_message]) ? ($this_message + ": " + $HTTP_error_codes[$this_message]) : "Unknown error" ;
									$error_list += "<tr><td colspan=6 class=body>" + $this_dates + "<br>" + $this_pages + "<br>" + $this_message + "<hr></td></tr>\r";
								}
								
							}
						}
						$output += $error_list;
					}
					
					if ($error_list) {
						// provide a button for clearing the error log
						$output += "<tr><td colspan=6 class=body>\r";
						$output += "<form name=clear method=post><input type=hidden name=clear value=1><input type=hidden name=month value=" + $month + "></form>\r";
						$output += "<script language=JavaScript>\n function clearErrors() {\r";
						$output += "if (confirm('Are you sure you want to clear the error log for this month?')) { document.clear.submit(); }\r }\r";
						$output += "</script>\r";
						$output += "<a href=JavaScript:clearErrors()>Clear error log</a>\r";
						$output += "</td></tr>\r\r";
					} else {
						// or just show the blank marker
						$output += "<tr><td colspan=6 class=body>" + $blank_marker + "</td></tr>\r\r";
					}
					
					// more/top buttons after listings
					$output += "<tr><td colspan=6 class=body>" + $button + "</td></tr>\r\r";
					
					// space between sections
					if ($h == 0) {
						if ($one_big_page) { $output += "<tr><td colspan=6><img src=../graphics/spacer.gif height=36 width=1></td></tr>\r\r"; }
					}
					
				}
	
			}

		}
		
	// finish off the table, and we're done
			
		$output += "</table><br>\r\r";
		if (!$section) {
			$output += "<p class=body>&lt;&ndash; <a href=reporter.asp>Months</a></p>\r\r";
		} else {
			$output += "<p class=body>&lt;&ndash; <a href=reporter.asp?month=" + $month + ">Top " + $top_n + "'s</a></p>\r\r";
		}	
		
	
// otherwise, build a menu of all the available data files
	
	} else {
	

	// get a list of all the files in the data directory and sort it
	
		$data_files = new Array();

		FSO = Server.CreateObject("Scripting.FileSystemObject");
		$dir = FSO.GetFolder(absolute_path($data_directory, "filesystem"));
		$dir_files = new Enumerator($dir.Files);
		if ($dir_files) {
			$re = /^\d{4}-\d{2}.txt$/;
			for (; !$dir_files.atEnd(); $dir_files.moveNext() ) {
				$file = $dir_files.item().Name;
				if ($re.test($file)) {
					$data_files.push($file);
				}
			}
		} else {
			$output += "<b>Error:</b> Can't read the contents of the data directory " + $data_directory + "<p>\r\r";
		}
		FSO = "";
		
		function sort_descending_files (a,b) {
			// sort the files names numerically
			a = parseInt(a.replace(/[^\d]/g, ""));
			b = parseInt(b.replace(/[^\d]/g, ""));
			return ( (a>b) ? -1 : ( (a<b) ? 1 : 0 ) )	
		}
		$data_files.sort(sort_descending_files);
		$data_files_count = $data_files.length;
					
	
	// change each element in the data_files array to an array of information about the file
	
		$page_views_total = 0;
		$last_page_view = "NA";
		for ($i=0; $i < $data_files_count; $i++) {
			$name = $data_files[$i];
			$data_files[$i] = new Array();
			$data_files[$i]["name"] = $name;

			$page_views = 0; // a simple count will do here
			$visits = new Array(); // but here we have to remember each visit to avoid duplicates
			$time_cumulative = 0; // we'll count this in seconds and then average it later
			$visitors = new Array(); // here, again, we have to remember each visitor to avoid duplicates
			
			$text = get_file_simple($data_directory + $data_files[$i]["name"]);
			$data_files[$i]["legacy_file"] = ($text.indexOf("(visitors not tracked)") != -1); // this prevents us from displaying inaccurate visitor and visit data if we encounter a file that predates that functionality
			$text = $text.split("\r");
			$next = new Array();
			for ($line_index=0; $line_index<$text.length; $line_index++) {
				$text[$line_index] = $text[$line_index].replace(/\\/g, "\\\\"); // a backslash at the end of a line causes problems, so remove those
				$next = $text[$line_index].split("\t");
				if ($next.length == $columns.length) { // make sure the line has all the elements we're expecting it to have

					// extract the host value out of the log entry
					$this_hosts = ($track_visitors) ? $next[3] : $next[2] ;
				
					// check the host and skip this line if it matches our exclude hosts
					$include_this_host = 1;
					if ($exclude_from_hosts) {
						for ($k=0; $k < $exclude_from_hosts_count; $k++) {
							$re = new RegExp($exclude_from_hosts[$k], "i");
							if ($re.test($this_hosts)) { $include_this_host = 0; }
						}
					}

					// increment our various count variables
					if ($include_this_host) {
						$page_views++;
						if ($track_visitors) {
							// extract the date and visitor values out of the log entry
							$this_dates = $next[0];
							$this_visitors = $next[1];

							// don't track this at all if the visitor ID is missing (e.g. the client didn't accept the cookie)
							if (!$this_visitors) {
								$page_views--;
							} else {
							
								// counting visitors (unique visitor IDs this month) is easy
								// we're identifying visitors by the visitor ID
								$visitors[$this_visitors] = $this_visitors; // this automatically overwrites earlier entries with the same visitor, so we end up with a count of unique visitors
	
								// counting visits (page views by a visitor with no more than a $visit_expires minutes delay between them) is harder 
								if (!$visits[$this_visitors]) {
									// add a new visit entry with this time
									$visits[$this_visitors] = $this_dates; // we're identifying visits by the visitor ID and date
								} else {
									$last_dates = $visits[$this_visitors];
									$interval = (get_unix_time($this_dates) - get_unix_time($last_dates));
									if ($interval < ($visit_expires * 60)) {
										// if the last page view was less than $visit_expires minutes ago, update the visit entry with the time of this latest page view
										$visits[$this_visitors] = $this_dates;
										// also, add the time between these two page views to the cumulative visit duration
										$time_cumulative = $time_cumulative + $interval;
									} else {	
										// otherwise, tag the old visit entry with the end time for that visit and add a new visit entry with this new time
										$visits[$this_visitors + " " + $last_dates] = $last_dates;
										$visits[$this_visitors] = $this_dates;
										// note that we can't accurately say how long the user was on that last page, so we don't increment $time_cumulative here; this means our times will be lower than reality, but consistently lower; this seems to be the industry standard way to handle this problem
									}
								}
							
							}
						}
					}
					
				}
			}
					
			// do the math and save the results for this file into an array for display in a moment
			if ($page_views) {
				$data_files[$i]["page_views"] = $page_views;
				if ($track_visitors) {
					$visits_count = 0; // we need the next two lines because $visits is an associative array (object) and therefore doesn't have a length property
					for ($visit in $visits) { $visits_count++; }
					$visits = $visits_count;
					$visitors_count = 0; // we need the next two lines because $visitors is an associative array (object) and therefore doesn't have a length property
					for ($visitor in $visitors) { $visitors_count++; }
					$visitors = $visitors_count;
					$data_files[$i]["visits"] = $visits;
					$data_files[$i]["pages_per_visit"] = (Math.round($page_views / $visits * 100) / 100);
					$data_files[$i]["time_per_visit"] = Math.round($time_cumulative / $visits);
					$data_files[$i]["visitors"] = $visitors;
					$data_files[$i]["visits_per_visitor"] = (Math.round($visits / $visitors * 100) / 100);
				}
			} else {
				$data_files[$i]["page_views"] = 0;
				if ($track_visitors) {
					$data_files[$i]["visits"] = 0;
					$data_files[$i]["pages_per_visit"] = "NA";
					$data_files[$i]["time_per_visit"] = "NA";
					$data_files[$i]["visitors"] = 0;
					$data_files[$i]["visits_per_visitor"] = "NA";
				}
			}
			
			// also keep track of the total page views for all files
			$page_views_total = $page_views_total + $page_views;
			if ($page_views > $page_views_greatest) { $page_views_greatest = $page_views; }

			// and get the last page view out of the first file, since we've sorted the files from newest to oldest
			if (($i == 0)&&($next != new Array())) {
				$last_page_view = $next[0];
			}
		}
		
		
	// print the file names and number of page views in a table
	
		$month_oldest = $data_files[$data_files_count - 1]["name"].substring(0, $data_files[$data_files_count - 1]["name"].length - 4);

		$output += "<p class=heading>Traffic since " + month_display($month_oldest) + "</p>\r\r";
		
		$output += "<p class=subheading>Last page view: " + $last_page_view + "</p>\r";
		$output += "<p class=subheading>Total page views: " + $page_views_total + "</p><br>\r\r";
		
		$output += "<table cellpadding=4 cellspacing=0 border=0>\r\r";
		
		$output += "<tr bgcolor=#CCCCCC valign=bottom>\r";
		$output += "<td class=subheading>Monthly&nbsp;reports</td>\r";
		$output += "<td colspan=2 class=subheading>Page&nbsp;views</td>\r";
		if ($track_visitors) {
			$output += "<td class=subheading>Visits</td>\r";
			$output += "<td class=subheading>Pages/visit</td>\r";
			$output += "<td class=subheading>Time/visit</td>\r";
			$output += "<td class=subheading>Visitors</td>\r";
			$output += "<td class=subheading>Visits/visitor</td>\r";
			$colspan = 8;
		} else {
			$colspan = 3;
		}
		$output += "</tr>\r\r";
		
		for ($i=0; $i < $data_files_count; $i++) {
			$month = $data_files[$i]["name"].substr(0, ($data_files[$i]["name"].length - 4));
			$output += "<tr>\r";
			$output += "<td class=body><a href=reporter.asp?month=" + $month + ">" + $month + "</a></td>\r";
			$output += "<td class=body align=right>" + $data_files[$i]["page_views"] + "</td>\r";
			$output += "<td width=" + $graph_width + "><font color=" + random_color() + "><img src=../graphics/spacer.gif height=4 width=" + (($data_files[$i]["page_views"] / $page_views_greatest) * $graph_width) + " border=1></font></td>\r";
			if ($track_visitors) {
				if ($data_files[$i]["legacy_file"]) {
					$output += "<td class=body colspan=5>(visitors not tracked)</td>\r";
				} else {
					$time_per_visit_minutes = Math.floor($data_files[$i]["time_per_visit"] / 60);
					$time_per_visit_seconds = $data_files[$i]["time_per_visit"] % 60;
					if ($time_per_visit_seconds < 10) { $time_per_visit_seconds = "0" + String($time_per_visit_seconds); }
					$time_per_visit_display = $time_per_visit_minutes + ":" + $time_per_visit_seconds;
					$output += "<td class=body>" + $data_files[$i]["visits"] + "</td>\r";
					$output += "<td class=body>" + $data_files[$i]["pages_per_visit"] + "</td>\r";
					$output += "<td class=body>" + $time_per_visit_display + "</td>\r";
					$output += "<td class=body>" + $data_files[$i]["visitors"] + "</td>\r";
					$output += "<td class=body>" + $data_files[$i]["visits_per_visitor"] + "</td>\r";
				}
			}
			$output += "</tr>\r\r";
		}
		
		$output += "<tr><td colspan=" + $colspan + ">&nbsp;</td></tr>\r\r";

		$output += "<tr><td colspan=" + $colspan + " bgcolor=#CCCCCC class=subheading>Other views</td></tr>\r\r";

		$output += "<tr><td colspan=" + $colspan + " class=body>\r";	
		$output += "<a href=\"JavaScript:window.open('realtime.swf?script_extension=asp&graph_color="+$graph_color+"&graph_image="+$graph_image+"&update_interval="+$update_interval+"','realtime','width=550,height=500,location=no,menubar=no,directories=no,toolbar=no,scrollbars=yes,resizable=yes,status=yes')\">Real-time display</a><br>\r\r";	
		$output += "<a href=" + $data_directory + ">Raw logs</a><br>\r";
		$output += "</td></tr>\r\r";
			
		$output += "</table><br>\r\r";
		
	}
	
	
//  print everything to the browser
	
	Response.write($output);
	

// if requested, show a performance report

	if ($show_performance) {
		$JScript_date = new Date();
		$this_performance_time = $JScript_date.getSeconds();
		$performance_times += "&nbsp;&nbsp;wrap up - " + ($this_performance_time - $last_performance_time) + " seconds <br>\r";
		$total_performance_time = $total_performance_time + ($this_performance_time - $last_performance_time);
		$last_performance_time = $this_performance_time;
	}

	if ($show_performance) {
		Response.write("Language: asp<br>\r");
		Response.write("Host: " + $my_host + "<br>\r");
		Response.write("Total page views:<br>" + $page_views_total + "\r");
		Response.write("Performance times:<br>" + $performance_times + "\r");
		Response.write("Total time: " + $total_performance_time + " seconds\r");
	}
	

//  we're done!

	Response.write("</div>\r");

	Response.write("</body></html>\r");

%>